--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    15:29:38 03/13/06
-- Design Name:    
-- Module Name:    SpiCtrl - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity SpiCtrl is
    Port ( mclk : in std_logic;
           rst : in std_logic;
           pinSS : in std_logic;
           pinSCK : in std_logic;
           pinMOSI : in std_logic;
           pinMISO : out std_logic;
			  pinTMSEN	: in std_logic);
end SpiCtrl;

architecture Behavioral of SpiCtrl is

------------------------------------------------------------------------
-- Signal Declarations
------------------------------------------------------------------------
	signal shiftreg  		: std_logic_vector(7 downto 0);
	signal ctrShiftOut	:	std_logic;

begin
	
	pinMISO <= shiftreg(7) when pinTMSEN = '1' else
			'Z';
	process	(pinSCK, pinMOSI, pinSS)																								
		begin

			if pinSS = '0' then
				if pinSCK'Event and pinSCK = '1' then
					shiftreg <= shiftreg (6 downto 0) & pinMOSI;
				end if;
			else 
				if pinSCK'Event and pinSCK = '1' then
					shiftreg(7) <= '0';
				end if;
			end if;
		end process;
	


end Behavioral;
